unit Unit1;

interface

uses
  System.SysUtils, System.Classes, JS, Web, WEBLib.Graphics, WEBLib.Controls,
  WEBLib.Forms, WEBLib.Dialogs, Vcl.Imaging.GIFImg, Vcl.Controls, Vcl.StdCtrls,
  WEBLib.StdCtrls;

type
  TForm1 = class(TWebForm)
    WebButton1: TWebButton;
    WebWaitMessage1: TWebWaitMessage;
    procedure WebFormCreate(Sender: TObject);
    [async] procedure WebButton1Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

procedure TForm1.WebButton1Click(Sender: TObject);
var
  i: Integer;
  d: double;
begin
  WebButton1.Tag := WebButton1.Tag + 1;
  WebButton1.Caption := IntToStr(WebButton1.Tag)+' Clicks - Wait';

  WebWaitMessage1.Show;

  asm await sleep(100); end;

  // busy work - takes only a couple of seconds
  d := 1;
  for i := 1 to 500000000 do
   d := d + sqrt(i*d)*sqrt(i*2*d)+sqrt(i*3*d)*sqrt(i*4*d);

  WebButton1.Caption := IntToStr(WebButton1.Tag)+' Clicks - Ready';

  WebWaitMessage1.Hide;
end;

procedure TForm1.WebFormCreate(Sender: TObject);
begin

  asm
    window.sleep = async function(msecs) {return new Promise((resolve) => setTimeout(resolve, msecs)); }
  end;

end;

end.